#pragma once

//#include <math.h>
#include <opencv2/opencv.hpp>
#include <vector>

using namespace std;

#define PI (3.14159)

class GMM {
public:
	GMM();
	~GMM();
	
private:

	vector< vector< vector<double> > > m_S;
	vector< vector< vector<double> > > m_InvS;
	vector< double > m_Det;
	vector< vector< double > > m_M;
	vector< double > m_Weight;

	vector< vector<double> > m_Data;
	
	vector< double > m_Prob;
	vector< vector< double > > m_Post;
	vector< vector< double > > m_Prior;

	
	int m_Dim;
	int m_nGaussian;
	double m_Norm;
	
	bool m_isLearn;
	
	int CalcPx(void);
	int CalcInvDet(void);
	vector< vector<double> > InverseMatrix(vector< vector<double> > &s);
	double Det(vector< vector<double> > &s);
	int EMProb(int nk);
	int EMPar(int nk, double prior);
	double Prob(vector<double> &x, int k);
	
public:
	double Prob(vector<double> &x);
	int Learn();
	int SetData(vector<double> x);
	int Init(int dim, int nGaussian);
	inline void ClearData(void)
	{
		m_Data.clear();
	}
};

