#pragma once 

#include <opencv2/opencv.hpp>
#include "graph.h"
#include "GMM.h"
#include "ImagePyramid.h"

using namespace std;
using namespace cv;


class GraphCutsBlur 
{
public:
	GraphCutsBlur();
	~GraphCutsBlur();
	
private:
	double m_Lambda;
	
	
	Mat Segmentaiton(Mat &input, 
			Mat &objseed, Mat &bkgseed, 
			GMM &objmodel, GMM &bkgmodel,
			Mat &objdist, Mat &bkgdist
	);
	double DistanceColor(Mat &input, int x1, int y1, int x2, int y2);
	int DistanceTransform(Mat &input, Mat &objdist, Mat &bkgdist);
	template<typename T> T truncate(T a, T min, T max);

	
public:
	Mat Run(Mat &input, Mat &objseed, Mat &bkgseed, double lambda);
};
