////////////////////////////////////////
//
// Image Pyramid class
// written by tomoyuki nagahashi
//
////////////////////////////////////////

#include "ImagePyramid.h"

ImagePyramid::ImagePyramid() 
{
}

ImagePyramid::~ImagePyramid() 
{
}


////////////////////////
// set image
/////////////////////////
int ImagePyramid::SetImage(Mat &input)
{
	int narrow = input.cols < input.rows ? input.cols : input.rows;
	Mat source = input.clone();
	double size = 1.0;
	
	vector<Mat> origin;
	origin.push_back(source);
	m_Pyramid.push_back(origin);
	
	while(narrow > 60.0)
	{
		vector<Mat> blurs;
		Mat resize_image;
		resize(source, resize_image, Size(), size, size, INTER_LINEAR);
		for(int i = 10; i <= 20; i+=2)
		{
			double sigma = i*0.1;
			Mat blurimage;
			GaussianBlur(resize_image, blurimage, Size(7,7), sigma, sigma, BORDER_DEFAULT);
			blurs.push_back(blurimage.clone());
		}
		m_Pyramid.push_back(blurs);
		narrow *= 0.5;
		size *= 0.5;
	}
	return 0;
}


////////////////////////
// set seed
/////////////////////////
int ImagePyramid::SetSeed(Mat &input)
{
	int narrow = input.cols < input.rows ? input.cols : input.rows;
	Mat source = input.clone();
	double size = 1.0;
	
	vector<Mat> origin;
	origin.push_back(source);
	m_Pyramid.push_back(origin);
	
	while(narrow > 60.0)
	{
		vector<Mat> resize_image(1);
		resize(source, resize_image[0], Size(), size, size, INTER_LINEAR);
		m_Pyramid.push_back(resize_image);
		narrow *= 0.5;
		size *= 0.5;
	}
	return 0;
}

